@rem = '-*- Perl -*-';
@rem = '
@echo off
perl -S %0.cmd %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
';

#
# Perl script to update the NT registry with defaults for Perl
#

die "usage: regupdat <perl installation path>\n" 
    if (@ARGV != 1);

$installdir = shift;

die "Non-existant directory: $installdir\n" if ! -d $installdir;

unshift(@INC, "$installdir\\lib");

require "registry.pl";

print "Starting Registry update for installation directory $installdir\n";

&RegCreateKey($HKEY_LOCAL_MACHINE, 
	      "SOFTWARE\\Intergraph\\Perl\\4.036", $key) ||
    die "Can't open HKEY_LOCAL_MACHINE\\SOFTWARE\\Intergraph\\Perl\\4.036: $!";

&RegSetValueEx ($key, "PathName", 0, $REG_SZ, "$installdir\\bin\\perl.exe");
&RegSetValueEx ($key, "SoftwareType", 0, $REG_DWORD, 1);
&RegCloseKey ($key);

&RegCreateKey($HKEY_LOCAL_MACHINE, 
	      "SOFTWARE\\Intergraph\\Perl\\4.036\\Parameters", $key) ||
    die "Can't HKEY_LOCAL_MACHINE\\SOFTWARE\\Intergraph\\Perl\\4.036\\Parameters: $!";

&RegSetValueEx ($key, "BIN", 0, $REG_SZ, "$installdir\\bin");
&RegSetValueEx ($key, "PRIVLIB", 0, $REG_SZ, "$installdir\\lib");
&RegCloseKey ($key);

&RegCreateKey($HKEY_LOCAL_MACHINE, 
	      "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment",
	      $key) ||
    die "Can't get environment value: $!\n";

&RegQueryValueEx ($key, "Path", 0, $type, $path) 
    || die "can't get path value:$!\n";

#
# remove any element of path that contains an old perl path
#

$path = join(";", grep (! /perl/i, split(";", $path)));

#
# Now put perl's bin dir at the head of the path
#

&RegSetValueEx ($key, "Path", 0, $type, "$installdir\bin;$path;")
    || die "can't set path to $idir;$path:$!\n";

&RegCloseKey($key);

print "Finished with registry update\n\n";

print "NOTE: You must reboot for the path modifications to take effect!\n";

__END__
:endofperl
